/*-
 *  Copyright 2020 Beuth Hochschule für Technik Berlin, Hochschule für Technik Stuttgart
 * 
 *  This file is part of CityDoctor2.
 *
 *  CityDoctor2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  CityDoctor2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with CityDoctor2.  If not, see <https://www.gnu.org/licenses/>.
 */
package de.hft.stuttgart.citydoctor2.check.error;

import java.util.List;

import de.hft.stuttgart.citydoctor2.check.CheckError;
import de.hft.stuttgart.citydoctor2.check.ErrorId;
import de.hft.stuttgart.citydoctor2.check.ErrorReport;
import de.hft.stuttgart.citydoctor2.check.ErrorType;
import de.hft.stuttgart.citydoctor2.check.ErrorVisitor;
import de.hft.stuttgart.citydoctor2.check.HealingMethod;
import de.hft.stuttgart.citydoctor2.check.ModificationListener;
import de.hft.stuttgart.citydoctor2.datastructure.Geometry;
import de.hft.stuttgart.citydoctor2.datastructure.GmlElement;
import de.hft.stuttgart.citydoctor2.datastructure.Polygon;

/**
 * When a geometry contains two or more not connected geometries, this error is
 * created.
 * 
 * @author Matthias Betz
 *
 */
public class MultipleConnectedComponentsError implements CheckError {

	private static final long serialVersionUID = 2152069835068857036L;
	
	private Geometry geom;
	private List<List<Polygon>> components;

	public MultipleConnectedComponentsError(Geometry geom, List<List<Polygon>> components) {
		this.geom = geom;
		this.components = components;
	}

	public Geometry getGeometry() {
		return geom;
	}

	public List<List<Polygon>> getComponents() {
		return components;
	}

	@Override
	public void report(ErrorReport report) {
		report.add(geom);
		for (int i = 0; i < components.size(); i++) {
			List<Polygon> polygons = components.get(i);
			report.addPolygons("component nr: " + (i + 1), polygons);
		}
	}

	@Override
	public void accept(ErrorVisitor errorVisitor) {
		errorVisitor.visit(this);
	}

	@Override
	public boolean accept(HealingMethod method, ModificationListener l) {
		return method.visit(this, l);
	}

	@Override
	public String toString() {
		return "MultipleConnectedComponentsError [geom=" + geom + ", components=" + components + "]";
	}

	@Override
	public ErrorType getType() {
		return ErrorType.ERROR;
	}

	@Override
	public ErrorId getErrorId() {
		return ErrorId.GE_S_MULTIPLE_CONNECTED_COMPONENTS;
	}

	@Override
	public GmlElement getFeature() {
		return getGeometry();
	}
}
